The following two UDFs solve the same problem with two different
approaches.  Each adds a margin when printing a memofield (See
anomaly report).  Before using these functions, the HARDCR()
function must be issued on the memofield.


1)  Syntax: MARGPRNT( memofield )

MARGPRNT can be used in conjunction with a SET MARGIN command.
     
Example:
       SET PRINT ON
       SET MARGIN TO 7
       MARGPRNT(HARDCR(memofield))  
       SET PRINT OFF                
       SET MARGIN TO                

NOTE:  WINTER '85 will not allow a function to start a command
line.  The work-around is to assign the function to a variable.

2)  Syntax: MARGVAR( memofield, margin )

MARGVAR returns a character string with the specified margin
inbedded in it.  The margin in the SET MARGIN TO command must be
set to 0

Example:

     A) This will print the memofield on the screen with a
        margin of 5.

        margin = 5
        SET MARGIN TO 0
        ? MARGVAR(HARDCR(memofield), margin)

     B) This will create a memory variable then write it to
        a text file with a margin of 5.

        margin = 5
        var = MERGVAR(HARDCR(memofield), margin)
        MEMOWRIT("Temp.txt", var)

The following program illustrates how to use both functions.



* Program: Testmemo.prg
* Author:  Steve Hillbourne

SET PRINT ON
choice = 'Y'
margin = 0
note = ''

DO WHILE choice = 'Y'
   CLEAR
   @ 1, 10 SAY "ENTER MARGIN " GET margin RANGE 0,79
   READ
   @ 3,19 TO 21, 61
   note = MEMOEDIT(note, 4,20,20,60,.T.)
   CLEAR
   WAIT "TESTING MARGPRNT() -- PRESS ANY KEY"
   SET MARGIN TO margin
   MARGPRNT(HARDCR(note))
   SET MARGIN TO 0
   WAIT "TESTING MARGVAR() -- PRESS ANY KEY"
   ? MARGVAR(HARDCR(note),margin)
   WAIT
   CLEAR
   @ 20, 10 say "TEST ANOTHER ? " GET choice PICTURE "!"
   READ
ENDDO
USE
SET PRINT OFF

RETURN

**************************************************
FUNCTION MARGPRNT
PARAMETERS memo
length = LEN(memo)
position = 1
offset = 1

DO WHILE position < length
   * search for carriage return
   IF SUBSTR(memo,position,1) = CHR(13) 
      * print line at a time
      ? SUBSTR(memo, offset, position - offset)
      * skip CR/LF and start new line
      offset = position + 2
      position = position + 1
    ENDIF
    position = position + 1
ENDDO
?  SUBSTR(memo, offset)     && print last line

RETURN ''

**************************************************

FUNCTION MARGVAR
PARAMETERS memo,margin
length = len(memo)
position = 1
offset = 1
newmemo = ""

DO WHILE position < length
   * search for carriage return
   IF SUBSTR(memo,position,1) = CHR(13)
      * add margin within memofield
      newmemo = newmemo + SPACE(margin) +;
         SUBSTR(memo,offset,position+2-offset)
      * skip CR/LF and move pointer
      offset = position + 2
      position = position + 1
    ENDIF
    position = position + 1
ENDDO
* add last line
newmemo = newmemo + SPACE(margin) + SUBSTR(memo,offset)

RETURN newmemo

